package com.zt.plat.module.qms.resource.device.service;

import java.util.*;

import com.alibaba.fastjson.JSONObject;
import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceApplyPageReqVO;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceApplyRespVO;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceApplySaveReqVO;
import jakarta.validation.*;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DeviceApplyDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 设备通用流程,验收、降级、停用、报废、还原、启用 Service 接口
 *
 * @author 后台管理-1
 */
public interface DeviceApplyService {

    /**
     * 创建设备通用流程,验收、降级、停用、报废、还原、启用
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DeviceApplyRespVO createDeviceApply(@Valid DeviceApplySaveReqVO createReqVO);

    //创建临时数据
    CommonResult<DeviceApplyRespVO> createTempData(@Valid DeviceApplySaveReqVO createReqVO);

    //增加明细
    CommonResult<Boolean> addDetail(JSONObject param);

    //删除明细
    CommonResult<Boolean> removeDetail(JSONObject param);

    CommonResult<Boolean> saveDeviceApply(@Valid DeviceApplySaveReqVO updateReqVO);

    CommonResult<DeviceApplyRespVO> submitDeviceApply(DeviceApplySaveReqVO param);

    //更新设备状态
    void updateDeviceStateByApply(DeviceApplyDO entity, Integer switchState);

    /**
     * 更新设备通用流程,验收、降级、停用、报废、还原、启用
     *
     * @param updateReqVO 更新信息
     */
    void updateDeviceApply(@Valid DeviceApplySaveReqVO updateReqVO);


    /**
     * 删除设备通用流程,验收、降级、停用、报废、还原、启用
     *
     * @param id 编号
     */
    void deleteDeviceApply(Long id);

    /**
    * 批量删除设备通用流程,验收、降级、停用、报废、还原、启用
    *
    * @param ids 编号
    */
    void deleteDeviceApplyListByIds(List<Long> ids);

    /**
     * 获得设备通用流程,验收、降级、停用、报废、还原、启用
     *
     * @param id 编号
     * @return 设备通用流程,验收、降级、停用、报废、还原、启用
     */
    DeviceApplyDO getDeviceApply(Long id);

    /**
     * 获取申请详情，含意见内容
     */
    CommonResult<JSONObject> getWithOpinions(Long id);

    /**
     * 获得设备通用流程,验收、降级、停用、报废、还原、启用分页
     *
     * @param pageReqVO 分页查询
     * @return 设备通用流程,验收、降级、停用、报废、还原、启用分页
     */
    PageResult<DeviceApplyDO> getDeviceApplyPage(DeviceApplyPageReqVO pageReqVO);



}